Attribute VB_Name = "modAdvFuncCall"
Option Explicit

#Const ReleaseBuild = False


Private Declare Function PutMem4 Lib "msvbvm60" (ByVal pDst As Long, ByVal NewValue As Long) As Long

#If ReleaseBuild Then
  Private Declare Function WriteProcessMemory Lib "kernel32.dll" (ByVal hProcess As Long, ByRef lpBaseAddress As Any, ByRef lpBuffer As Any, ByVal nSize As Long, ByRef lpNumberOfBytesWritten As Long) As Long
  Private Declare Function GetCurrentProcess Lib "kernel32.dll" () As Long
#Else
  Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Private Declare Function PutMem2 Lib "msvbvm60" (ByVal pWORDDst As Long, ByVal NewValue As Long) As Long
  Private Declare Function GetMem4 Lib "msvbvm60" (ByVal pDWORDSrc As Long, ByVal pDWORDDst As Long) As Long
  Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
  Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
  
  Private Const GMEM_FIXED As Long = &H0
  Private Const MAX_PARAMS As Long = 10
  Private Const asmPUSH_imm32 As Byte = &H68
  Private Const asmRET_imm16 As Byte = &HC2
  Private Const asmCALL_rel32 As Byte = &HE8
#End If

Public Sub SetFunction(ByVal AddressOfPlaceholder As Long, ByVal AddressOfFunction As Long)
  #If ReleaseBuild Then
    Static t(1 To 5) As Byte
    
    If AddressOfPlaceholder = 0 Then Err.Raise 5
    If AddressOfFunction = 0 Then Err.Raise 5
    
    t(1) = &HE9
    PutMem4 VarPtr(t(2)), AddressOfFunction - AddressOfPlaceholder - 1 - 4
    WriteProcessMemory GetCurrentProcess, ByVal AddressOfPlaceholder, t(1), 5, ByVal 0&
  #Else
    Select Case AddressOfPlaceholder
    Case ReturnMe(AddressOf modAdvFuncCall.PlaceholderForParameterlessFunction)
      modAdvFuncCall.PlaceholderForParameterlessFunction AddressOfFunction
    Case ReturnMe(AddressOf modAdvFuncCall.PlaceholderFor1ParamFunction)
      modAdvFuncCall.PlaceholderFor1ParamFunction 0, AddressOfFunction
    Case Else
      Err.Raise 5
    End Select
  #End If
End Sub

#If Not ReleaseBuild Then
  Private Function ReturnMe(ByVal r As Long) As Long
    ReturnMe = r
  End Function
  
  Private Function CallFunction(ByVal FuncPointer As Long, ByVal ParamsCount As Long, Optional ByVal p1 As Long = 0, Optional ByVal p2 As Long = 0, Optional ByVal p3 As Long = 0, Optional ByVal p4 As Long = 0, Optional ByVal p5 As Long = 0, Optional ByVal p6 As Long = 0, Optional ByVal p7 As Long = 0, Optional ByVal p8 As Long = 0, Optional ByVal p9 As Long = 0, Optional ByVal p10 As Long = 0) As Long
    Dim i As Long, t As Long
    Dim hGlobal As Long, hGlobalOffset As Long
    
    If ParamsCount < 0 Then Err.Raise 5 'invalid call
    
    hGlobal = GlobalAlloc(0, 5 * MAX_PARAMS + 5 + 3 + 1)
    If hGlobal = 0 Then Err.Raise 7 'insuff. memory
      
    hGlobalOffset = hGlobal
    
    If ParamsCount > 0 Then
      t = VarPtr(p1)
      For i = ParamsCount - 1 To 0 Step -1
        PutMem2 hGlobalOffset, asmPUSH_imm32
        hGlobalOffset = hGlobalOffset + 1
        GetMem4 t + i * 4, hGlobalOffset
        hGlobalOffset = hGlobalOffset + 4
      Next
    End If
    
    '  
    PutMem2 hGlobalOffset, asmCALL_rel32
    hGlobalOffset = hGlobalOffset + 1
    PutMem4 hGlobalOffset, FuncPointer - hGlobalOffset - 4
    hGlobalOffset = hGlobalOffset + 4
    
    PutMem4 hGlobalOffset, &H10C2&        'ret 0x0010
    
    CallFunction = CallWindowProc(hGlobal, 0, 0, 0, 0)
    GlobalFree hGlobal
  End Function
#End If


#If ReleaseBuild Then
Public Function PlaceholderForParameterlessFunction() As Long
#Else
Public Function PlaceholderForParameterlessFunction(Optional ByVal PleaseIgnoreMe As Long = 0) As Long
#End If
  #If ReleaseBuild Then
    PlaceholderForParameterlessFunction = 0&
  #Else
    Static func As Long
    If PleaseIgnoreMe Then
      func = PleaseIgnoreMe
    Else
      If func Then PlaceholderForParameterlessFunction = CallFunction(func, 0)
    End If
  #End If
End Function


#If ReleaseBuild Then
Public Function PlaceholderFor1ParamFunction(ByVal p1 As Long) As Long
#Else
Public Function PlaceholderFor1ParamFunction(ByVal p1 As Long, Optional ByVal PleaseIgnoreMe As Long = 0) As Long
#End If
  #If ReleaseBuild Then
    PlaceholderFor1ParamFunction = 0&
  #Else
    Static func As Long
    If PleaseIgnoreMe Then
      func = PleaseIgnoreMe
    Else
      If func Then PlaceholderFor1ParamFunction = CallFunction(func, 1, p1)
    End If
  #End If
End Function

